function main_script_SPAE_release

%% load your data
X_Train             = cell(1,num_view);
Label_Train         = cell(1,num_view);



%% AutoEncoder paramter setting
options.Method      = 'CG';
options.MaxFunEvals = options.maxIter*2;
options.TolX        = 1e-9;

AEopts.output       = 'sigm';
AEopts.activation_function = 'sigm';
AEopts.lambda       = 0;


% re-scale the intensity to [0, 1]
for i=1:num_view
    X_Train{i}          = X_Train{i}/255;
end



[ndim, num_sample_per_view] = size(X_Train{4});

%% training
X_Train_all = [];
Label_Train_all = [];
for i = 1:num_view
    X_Train_all =[X_Train_all  X_Train{i}];
    Label_Train_all = [Label_Train_all Label_Train{i}];
end

for nHiddens        = 5000
    for nHiddenLayers   = [3]
        options.maxIter     = 1000;
        netSizes            = [ndim repmat(nHiddens, 1, nHiddenLayers) ndim];
        AESizes             = netSizes;
        
        % AutoEncoder training
        if ~exist(model_path, 'file')
            SAE = [];
            AEinput             = X_Train_all;
            for k = 1 : nHiddenLayers
               AEoutput = X_Train_all;
               AEoutput(:,1:num_sample_per_view*k) = repmat(X_Train{k+1},1,k);
               AEoutput(:,num_sample_per_view*(num_view-k)+1:end) = repmat(X_Train{num_view-k},1,k);

               AESizes_k = [netSizes(k) netSizes(k+1) ndim];
               initTheta           = thetaInit( AESizes_k );
               theta               = minFunc( @(p)CostGradComputing( p , AEinput , AEoutput ,AESizes_k, AEopts), initTheta , options);
               
               ae_model                  = theta2WMatrix( theta , AESizes_k );
               
               SAE{k} = ae_model;        
               
               ae = FeedForwardPass( AEinput , ae_model , AESizes_k ,AEopts);
               AEinput = ae.a{end-1};        
            end
            
            ae_model = [];
            for k = 1 : nHiddenLayers
                ae_model.W{k} = SAE{k}.W{1};
                ae_model.b{k} = SAE{k}.b{1};
            end
            ae_model.W{k+1} = SAE{k}.W{2};
            ae_model.b{k+1} = SAE{k}.b{2};
            
            ae = ae_model;
            save(model_path, 'ae','SAE');
        else
            m = load(model_path);
            ae_model = m.ae;
            SAE = m.SAE;
        end
        
        
        
        % fine tune
        if ~exist(overall_model_path, 'file')
            AEinput = X_Train_all;  
            AEoutput            = repmat(X_Train{4},1,num_view);
            AESizes         = netSizes;
            initTheta           = thetaInit( AESizes,  ae_model.W, ae_model.b);
            theta               = minFunc( @(p)CostGradComputing( p , AEinput , AEoutput ,AESizes, AEopts), initTheta , options);
            ae_model                  = theta2WMatrix( theta , AESizes );

            ae = ae_model;
            save(overall_model_path, 'ae','SAE');
        else
            m = load(overall_model_path);
            ae_model = m.ae;
            SAE = m.SAE;
        end
    end
end